%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}
  \center{\huge{\bf Object Oriented Programming in Fortran}}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientation in Fortran}

    Some differences to 'proper' OOP languages (e.g. C++):
    \begin{itemize}
        \item no multiple inheritance
        \item less sophisticated polymorphism
        \item no templates! (that's a pain)
    \end{itemize}

    Some further reading:
    \begin{itemize}
        \item \href{https://fortranwiki.org/fortran/show/Object-oriented+programming}{FortranWiki}
        \item \href{https://www.pgroup.com/blogs/posts/f03-oop-part1.htm}{PGI introduction}
    \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Object Orientation in Fortran}

  A {\tt type} is a "class". It\\
  \begin{itemize}
    \item can now also contain procedures (subroutines or functions)
    \item can extend other types and inherit their data and Methods
    \item can be declared {\tt abstract}
  \end{itemize}

{\small
\lstset{language=Fortran}
\begin{lstlisting}
  type [, extends(parent_t)] :: new_type_t
    real,    private :: some private_variable
    integer, public  :: some_public_variable
  contains
    procedure :: do_something => new_type_do_something
  end type
\end{lstlisting}
}

\end{frame}
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Object Orientation in Fortran: type bound methods}

\begin{itemize}
  \item Definition of type-bound methods:
  \begin{itemize}
    \item First argument needs to the object itself (behaviour can be changed)
    \item This needs to be declared as\\
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
  subroutine new_type_do_something(this, variable)
    class(new_type_t), intent(...) :: this
    ...
  end subroutine new_type_do_something
\end{lstlisting}
}
  \end{itemize}
  \item Methods can override those of a parent class.
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Object Orientation in Fortran: Abstract types}
  Abstract types
  \begin{itemize}[<+->]
    \item Cannot be instantiated
    \item can define deferred procedures
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
  procedure(new_type_do_something), deferred :: do_something
\end{lstlisting}
}
    \item Deferred methods need an abstract interface
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
  abstract interface
    subroutine new_type_do_something(this, variable)
      class(new_type_t), intent(inout) :: this
      integer,           intent(in)    :: variable
    end subroutine new_type_do_something
  end interface
\end{lstlisting}
}
  \item non-abstract children {\bf must} implement deferred methods.
  \end{itemize}
  
\end{frame}
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Object Orientation in Fortran: Polymorphism}
  
Assume:
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
  type :: parent_t
    integer, public :: data_parent
  end type parent_t

  type, extends(parent_t) :: child_t
    integer, public :: data_child
  end type child_t
\end{lstlisting}
}
Inside a subroutine polymorphic argument:
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
subroutine test(object)
  class(parent_t), intent(in) :: object ! declared type: parent_t

  print *, object%data_parent ! allowed
  ! print *, object%data_child  ! NOT allowd !!

  end subroutine
\end{lstlisting}
}
Only direct access to data and methods of the declared type.

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Object Orientation in Fortran}
  
  Polymorphism: {\tt select type() construct}
  {\tiny
  \lstset{language=Fortran}
  \begin{lstlisting}
  subroutine test(object)
    class(parent_t), intent(in) :: object
    
    print *, object%data_parent ! allowed
    
    select type(ptr => object)
    class is(child_t)
      print *, ptr%data_child  !  allowd !!
    end select

    end subroutine
  \end{lstlisting}
  }
  
  \end{frame}
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientation in Octopus}

    Where would we like to use OOP?

    \begin{itemize}
        \item Multisystem framework (more details later)
        \begin{itemize}
            \item systems
            \item interactions
            \item propagators
        \end{itemize} 
        \item other 'objects':
        \begin{itemize}
            \item Hamiltonians
            \item operators (derivatives, ...)
            \item grids, meshes
        \end{itemize} 
        \item low level objects:
        \begin{itemize}
            \item mpi groups and communicators
            \item linked lists
            \item iterators
        \end{itemize} 
        \item This is work in progress...
    \end{itemize}

\end{frame}

